--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.

room {
nam = 'Восточная комната';
pic = 'img/east'..picext;
way = {path{'В зал','Зал'}};
soundReact = function(s, sound)
                if _'РисунокВК'.key=='рты' then return true end;
                if sound == 'Вопль' then
                    pn('По стенам проходит рябь. Изображения ушей таят одно за другим, вслед за ними исчезают и другие рисунки. В комнате становится светлее. Вы смотрите вверх и видите пару горящих свечей, которых только что тут не было. Контур лица на стене выдвигается вперёд и приобретает женские черты. Глаза на нём закрыты, а выражение — неприятно. Кажется, словно его разрывает внутреннее напряжение.')
                    remove('Ухо')
                    remove('Губы')
                    _'Восточная комната закрытая'.pic = 'img/east_close_nothing'..picext
                    _'П Восточная комната'.walk='Восточная комната активированная'
                    if where('Веретено')^'Восточная комната' then place('Веретено','Восточная комната активированная') end
                    if where('Кувшин')^'Восточная комната' then place('Кувшин','Восточная комната активированная') end
                    addFace('Лик плачущий')
                    walk 'Восточная комната активированная'
                elseif sound == 'ВопльСлабый' then
                    pn 'Вы ясно видите, как уши на стенах становятся чётче и даже немного шевелятся, но силы звука недостаточно, чтобы разбудить комнату.'
                else
                    pn 'Вам показалось, словно изображения ушей стали немного чётче, но это явно не тот звук, что они ждали услышать.'
                end -- if
              end; -- func
}:with{

obj{
dsc = 'Тесный пустой чулан. Слева и справа прямо на стенах углём нарисованы части человеческих тел. Картинки схематичные и неровные, словно их рисовал ребёнок. Они перемешаны друг с другом как придётся и иногда накладываются друг на друга. Глаза, руки, ступни, ладони...';
};

obj{
nam = 'РисунокВК';
key = 'рты';
dsc1 = 'но чаще всего — {рты}. Открытые и закрытые, кричащие и со стиснутыми зубами.';
dsc2 = 'но чаще всего — {уши}. Большие и маленькие, с мочками и без.';
dsc = function(s)
        if s.key=='рты' then return s.dsc1 end;
        if s.key=='уши' then return s.dsc2 end;
        return 'Ошибка!'
    end;
act = function(s)
        if s.key=='рты' then return 'Большой рот во сне обещает изобилие. Но если он стиснут — это к болезни. Да, это всё никогда не получалось применять к делу.' end;
        if s.key=='уши' then return 'Увидеть ухо во сне — знак скорой вести. Но если оно отдельно, значит сновидца ожидает развод. Хорошо, что вы не женаты и можно на этот счёт не волноваться.' end;
        return 'Ошибка!'
    end;
used = function(s,w) 
            if w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вам не кажется хорошей идеей смывать рисунок водой.'
            else
                return'Это просто рисунок, ничего не возможно с ним сделать.'
            end --if
        end; -- func
};

obj{
dsc = 'На передней стене отмечен пустым овалом контур лица. И как раз его все эти носы и зубы обходят стороной, словно опасаясь оказаться на разумном месте.';
};

} -- Здесь заканчиваются предметы восточной комнаты




room {
nam = 'Восточная комната закрытая';
pic = 'img/east_close'..picext;
disp = 'Восточная комната';
soundReact = function(s, sound)
                if sound == 'Вопль' then
                    pn('Ничего не происходит. Комната остаётся безучастной: здесь никому ничего не нужно.')
                elseif sound == 'ВопльСлабый' then
                    pn 'Ничего не происходит. Комната остаётся безучастной: здесь никому ничего не нужно.'
                else
                    return true
                end -- if
              end; -- func
onenter = function(s)
                _'Губы':enable()
                _'Ухо':enable()
                end;
}:with{

obj {
dsc = 'Крошечное квадратное помещение. Стены пустые и ровные. Такой же ровный и прямой пол под ногами. Вы словно оказались внутри большой коробки.';
};

obj {
nam = 'Губы';
dsc = 'Прямо перед вами из стены выступают толстые плотно сжатые {губы}.';
act = function(s)
        pn 'Вы осторожно прикасаетесь к губам и они втягиваются в стену.'
        s:disable()
        lifeon('Вопль')
        _'РисунокВК'.key='рты';
        return true;
        end;
used = function(s,w)
            if w^'Цепь с крюком' then 
                pn 'Тут нет ничего, за что можно было бы зацепиться.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Стена не будет это есть.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Губы — это то, что говорит, а не слушает.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вы слегка смачиваете губы водой из кувшина. Не похоже, что это даёт хоть какой-то эффект.'
            elseif w^'Веретено' then
                s:act()
            elseif w^'Молот' then
                pn 'Опыт подсказывает вам, что размахивать молотом просто так не стоит.'
            elseif w^'Клещи' then
                pn 'Тут не за что ухватиться.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end
        end;
};

obj {
nam = 'Ухо';
dsc = 'Рядом с ними огромное {ухо} барельефом выдаётся вперёд.';
act = function(s)
        pn 'Вы осторожно прикасаетесь к уху и оно втягивается в стену.'
        s:disable()
        lifeoff('Вопль')
        _'Вопль'.count = _'Вопль'.maxcount
        _'РисунокВК'.key='уши'
        return true;
        end;
used = function(s,w)
            if w^'Цепь с крюком' then 
                pn 'Вы вешаете крюк на ухо и смотрите какое-то время на результат. Это было бесполезно.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'У груза есть петелька, но на ухо её не нацепить.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Ухо выглядит неживым. Возможно, оно действительно хочет что-то услышать, но что именно и где?'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                s:act()
            elseif w^'Веретено' then
                s:act()
            elseif w^'Молот' then
                pn 'Опыт подсказывает вам, что размахивать молотом просто так не стоит.'
            elseif w^'Клещи' then
                pn 'Не стоит отрывать ухо от стены.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end
        end;
};

'Проход наружу';

} -- Конец предметов закрытой комнаты



room {
nam = 'Восточная комната активированная';
disp = 'Восточная комната';
pic = 'img/face'..picext;
soundReact = function(s, sound) -- Необходимо активировать изменение лица при выпускании громких звуков из кувшина
                if sound == 'Колокол' or sound == 'Лязг' or sound == 'Стук' or sound == 'Вопль' then
                       _'Лик':change()
                end --if
              end; -- func
way = {path{'В зал','Зал'}};
}:with{

obj {
dsc = 'Пустая квадратная комната. Душно и пахнет пылью. Над входом, почти под самым потолком горят две свечи. Рисунков углём на стенах больше нет, а сами они испещрены вертикальными неровными полосами.';
};

'Лик';
} -- Конец предметов активированной комнаты



obj {
nam = 'Вопль';
maxcount = 5;
count = 5;
life = function(s)
    --dprint(s.count)
    s.count = s.count - 1
    if s.count < 0 then
                    -- Слышимость звука
                    if here()^'Снаружи' then
                        pn 'Внезапно откуда-то изнутри дома раздаётся истошный вопль.'
                    elseif here()^'Восточная комната закрытая' then
                        pn 'Вы слышите короткий вскрик где-то неподалёку. Вы не смогли понять, откуда он донёсся.'
                    elseif here()^'Восточная комната' then
                        pn 'Внезапно вас пробирает озноб. На ваших глазах десятки нарисованных ртов вдруг сжимают губы и хором исторгают из себя судорожный крик.'
                    else 
                        pn 'Вы слышите короткий вскрик где-то рядом.'
                    end
                    -- Видим иногда автозакрытие крышки
                    if where('Кувшин')==here() and _'Кувшин'.sound=='' then
                             pn 'Вы замечаете, что крышка кувшина захлопнулась.'
                             end
                    -- Заряжаем кувшин по возможности
                    if where('Кувшин')^_'Восточная комната' and _'Кувшин'.sound=='' 
                             then  
                             _'Кувшин'.sound = 'Вопль'
                             _'Кувшин'.soundtext = 'Громкий истошный вопль охватывает всю комнату.'
                    elseif where('Кувшин')~=me() and _'Кувшин'.sound=='' then
                             _'Кувшин'.sound = 'ВопльСлабый'
                             _'Кувшин'.soundtext = 'Из кувшина раздаётся вопль, но звучит он как-то тихо и не впечатляет.'
                             end
                    -- Перезарядка объекта
                    s.count = s.maxcount
                    lifeoff(s)
                    end
    end;
};
