--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.



-- Добавляем новое лицо и сразу переводим на него
function addFace(newFace)
    _'Лик'.changeList[#_'Лик'.changeList+1] = newFace
    _'Лик'.changeCurrent = #_'Лик'.changeList
    _'Лик'.obj:zap()
    place(_'Лик'.changeList[_'Лик'.changeCurrent],_'Лик')
end


obj {
nam = 'Лик';
--dsc = 'Из стены выступает женский {лик}.'; -- Описание лика зависит от changeCurrent за счет того, что в obj лежит нужный подобъект
change = function(s)
        if not inspect(s) then return false end
        if s.changeList[s.changeCurrent]=='Лик перекошенный' then
                            pn 'От резкого звука лицо напрягается и только сильнее скалит зубы.'
                            return true
                            end
        s.obj:zap()
        s.changeCurrent = s.changeCurrent+1
        if s.changeCurrent>#s.changeList then s.changeCurrent = 1 end
        place(s.changeList[s.changeCurrent],s)
        pn 'Лицо на стене корчится от резкого звука и его выражение меняется.'
        end;
changeCurrent = 1;
changeList = {'Лик спокойный'};
}:with{

obj {
nam = 'Лик спокойный';
dsc = 'На передней стене барельефом выступает женское {лицо}. Черты его безжизненны.';
act = 'Лицо ничего не выражает, но это не столько спокойствие, сколько безразличие и апатия. Рот слегка приоткрыт, губы оставляют маленькую щель.';
stage = 1;
used = function(s, w)
        if w^'Веретено' and s.stage ==1 then 
                    pn 'Вы вставляете в щель острый конец веретена и слегка нажимаете на него. Рот приоткрывается и выпускает изнутри длинную цепь с крюком на конце, которая свешивается почти до пола.'
                    s.stage=2;
                    s.act = 'Глаза закрыты. Кажется, что ему безразлично всё происходящее.';
                    place('Цепь из лица',s)
            elseif w^'Цепь с крюком' then 
                pn 'Это теперь не починить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Лицу эта вещь не нужна.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Лицу это не нужно.'
            elseif w^'Веретено' then
                pn 'Второй раз не получится.'
            elseif w^'Молот' then
                pn 'Не стоит без причин размахивать молотом.'
            elseif w^'Клещи' then
                pn 'Что именно вы предлагаете выдрать?'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end
        end;
};

} 

obj {
nam = 'Цепь из лица';
dsc = 'Изо рта свешивается стальная {цепь}.';
act = 'Не выдёргивается.';
used = function(s, w)
        if w^'Клещи' then 
                    pn 'Вам удается найти не до конца скованное звено и разжать его клещами.'
                    take('Цепь с крюком')
                    _'Лик спокойный'.stage = 3;
                    _'Лик спокойный'.act = 'Изо рта свешивается короткий фрагмент цепи.';
                    s:disable()
            elseif string.match(w.nam,'Вес%d') then
                pn 'Груз можно повесить на крюк за петлю, но не похоже, чтобы это давало эффект.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'У кувшина нет ручки, подвесить его не получится.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Без горна, да на весу разбить молотом звено у вас нет шансов.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Ничего не получилось.'
            else
                return false
            end
        end;
}


obj {
nam = 'Цепь с крюком';
inv = 'Похожа на те, что висят в центральном зале.';
used = function(s, w)
        if w^'Клещи' then 
                pn 'У неё было только одно слабое звено.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Груз можно повесить на крюк за петлю, но что толку?'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Цепь и так достаточно чиста, нет нужды её мыть.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы громко ударяете молотом по цепи.'
                makeSound('Лязг', 'Из кувшина вырывается резкий металлический лязг.')
                _'Лик':change()
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Это никак не соединить.'
            else
                return false
            end
        end;
}

obj {
nam = 'Лик озлобленный';
dsc = 'На передней стене барельефом выступает женское {лицо}. Оно пристально смотрит вам в глаза. Рот растянут в злом оскале.';
act = 'Лицо очень напряжено. Вы можете пересчитать все вздутые жилы и квадратные, нечеловеческие зубы, словно вставленные в пазы на скульптуре.';
used = function(s,w)
            if w^'Клещи' then
                        pn 'Такие эксперименты не вполне безопасны, но вы всё-таки пробуете клещами по очереди несколько зубов, пока один из них не выскакивает из стены.'
                        take 'Вес4'
                        pn 'В ответ лицо перекашивает от ярости, глаза сужаются до двух тоненьких щёлочек. А разинутая пасть выдаётся вперёд, теряя ещё сильнее человеческий облик.'
                        table.remove(_'Лик'.changeList, _'Лик'.changeCurrent)
                        addFace('Лик перекошенный')
                        
            elseif w^'Молот' then
                pn 'Вы пока не видите причин обострять этот конфликт.'
            elseif w^'Цепь с крюком' then
                pn 'У вас нет идей, как их соединить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Лицу это не интересно.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Этому лицу вода ни к чему.'
            elseif w^'Веретено' then
                pn 'Только если в глаз воткнуть. Но не стоит сразу впадать в крайности.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Вот уж чего оно не собирается делать, так это плакать.'
            else
                return false
            end
        end; -- func
};


obj {
nam = 'Лик перекошенный';
dsc = 'На передней стене барельефом выступает {лицо}. Глаза его сужены, пасть широко открыта и напряжена. Черты перекошены от ярости.';
act = 'Вы стараетесь держать это в поле своего зрения. Кажется, оно не шевелится больше, но лучше соблюдать {$w|ос`то`рож`ность.}';
used = function(s,w)
            if w^'Молот' then
                    pn 'Вы взвешиваете молот в руке и прикидываете путь отхода. Может это и не лучшая идея, но других у вас нет. Глубоко вздохнув, вы наносите сильный удар прямо по лбу. В лице проскакивает удивление, взгляд приобретает стеклянное выражение и длинная трещина пересекает лицо наискосок, словно зачёркивая его.'
                    table.remove(_'Лик'.changeList, _'Лик'.changeCurrent)
                    addFace('Лик разбитый')
                    makeSound('Трещина', 'Из кувшина вырывается громкий звук, словно деревянная доска лопается пополам.')
            elseif w^'Цепь с крюком' then
                pn 'Там нет глотки, в которую можно было бы опустить цепь.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Нет, обратно это не вставить.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Оно точно не хочет пить.'
            elseif w^'Веретено' then
                pn 'Там нет глотки, куда можно было бы бросить веретено.'
            elseif w^'Клещи' then
                pn 'Вам не нравится мысль продолжать вырывать зубы.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Бесполезно.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'Лик разбитый';
dsc = 'На передней стене барельефом выступает женское {лицо}. Глаза его широко открыты, а само оно разрезано пополам глубокой трещиной и кажется совершенно безжизненным.';
act = 'Трещина проходит наискосок через правый глаз, нос и уголок рта. В выражении лица считывается удивление. Остаётся надеяться, что это не создаст проблем в дальнейшем.';
withpearl = true;
used = function(s,w)
            if w^'Веретено' and s.withpearl then
                pn 'Острым концом веретена вы осторожно изучаете дно трещины и достаете оттуда маленькую чёрную жемчужину.'
                s.withpearl = false
                bpearlFound()
            elseif w^'Веретено' and not s.withpearl then
                pn 'Больше здесь ничего нет.'
            elseif w^'Цепь с крюком' then
                pn 'Трещина не настолько большая, чтобы в неё можно было опустить цепь.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Бесполезно.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'В качестве извинения вы протираете лицо водой, но никакого эффекта это не производит.'
            elseif w^'Молот' then
                pn 'Хватит с него.'
            elseif w^'Клещи' then
                pn 'Вам не нравится идея продолжать вырывать зубы.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end
        end;
};



obj {
nam = 'Лик изнеможденный';
dsc = 'На передней стене барельефом выступает женское {лицо}. Осунувшееся, усталое, некрасивое.';
act = 'Оно словно вымотано тяжёлой работой или болезнью. Глаза открыты но расфокусированы. Губы слегка приоткрыты.';
done = false;
used = function(s,w)
            if w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
        elseif w^'Кувшин' and _'Кувшин'.withwater then
                if s.done then pn 'Вы ещё раз поете лицо водой из кувшина, но больше ничего не происходит.' return true end
                pn 'Вы наклоняете кувшин и льёте воду тоненькой струйкой на усталые губы. Вода исчезает где-то внутри. Спустя несколько глотков вы слышите тихий вздох, и лицо исторгает изо рта длинный прямоугольный предмет. Вам кажется, что теперь лицо выглядит несколько лучше.'
                take 'Вес10'
                s.done = true
                return true
            elseif w^'Цепь с крюком' then
                pn 'Крюк тут не поможет.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Лицу это не интересно.'
            elseif w^'Веретено' then
                pn 'Вы нащупываете канал, идущий вглубь, но на веретено лицо никак не реагирует.'
            elseif w^'Молот' then
                pn 'Кажется, ему и так плохо.'
            elseif w^'Клещи' then
                pn 'Кажется, ему и так плохо.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
};



obj {
nam = 'Лик плачущий';
dsc = 'На передней стене барельефом выступает женское {лицо}. Страдание оставило на нём свою печать. Так выглядит человек, сдерживающий слёзы из последних сил.';
act = 'Глаза фигуры закрыты, под ними вы замечаете маленькие пустые углубления в форме капель.';
done = false;
used = function(s,w)
        if w^'Слеза' then
                if s.done then pn 'Это бесполезно.' return true end
                pn 'Вы вставляете слезу в углубление и смотрите как она тает, впитываясь в стену. В ответ из глаз начинают течь тоненькие струйки воды. Вы слышите тихий вздох, и лицо исторгает изо рта длинный прямоугольный предмет.'
                take 'Вес5'
                remove 'Слеза'
                s.done = true
                return true
        elseif w^'Цепь с крюком' then
                pn 'Крюк тут не поможет.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Лицу это не интересно.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Лицо игнорирует воду из кувшина.'
            elseif w^'Веретено' then
                pn 'У вас нет идей, как это использовать.'
            elseif w^'Молот' then
                pn 'Не стоит, ему и так плохо.'
            elseif w^'Клещи' then
                pn 'Не стоит, ему и так плохо.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            else
                return false
            end -- if
        end; --func
};
