--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.


room {
nam = 'Зал';
    pic = 'img/hall_before'..picext;
way = {'Западный коридор', 
        path{'П Северная комната', 'На север', 'Северная комната'}:close(),
        path{'П Южная комната', 'На юг', 'Южная комната'}:close(),
        path{'П Восточная комната', 'На восток', 'Восточная комната'}:close()   };
}:with{

obj_1p {
dsc = 'Ни свечей, ни окон... в зале должна была бы стоять полутьма, но здесь даже немного светлее, чем снаружи.';
act_1 = 'Над головой у вас стопила теряются в темноте, потолка вы не видите.';
};

obj {
nam = 'Помост';
dsc = '^Точно в центре средокрестья стоит невысокий деревянный {помост} с квадратным {$w|углу`бле`нием}.';
act = 'Грубая квадратная {$w|конст`рук`ция} из досок. В середине прорезан глубокий паз сантиметров двадцать в длину.';
used = function(s,w)
            if w^'Крест' then
                        replace('Помост', 'КрестРаб')
                        _'Зал'.pic = 'img/hall'..picext
                        remove 'Крест'
                        _'Про двери':disable()
                        return 'Вы устанавливаете крест в нишу и слышите как из-за дверей раздаются лязгающие звуки.'
            elseif w^'Цепь с крюком' then
                return false
            elseif string.match(w.nam,'Вес%d') then
                pn 'Груз не помещается в паз.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                pn 'У вас нет идей, как это соединить.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вы выливаете внутрь паза немного воды. Никакого эффекта не заметно.' -- TODO Можно подумать о том, чтобы клинить таким образом кр.
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Помост не нуждается в ремонте.'
            elseif w^'Клещи' then
                pn 'Опыт подсказывает вам, что помост ещё пригодится.'
            elseif w^'Гвоздь' then
                pn 'Помост не нуждается в ремонте.'
            elseif w^'Доски' then
                pn 'Доска подходит к пазу по размеру, но проку от этого не заметно.'
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end;
};

obj {
nam = 'Лежалово';
dsc = 'На нём лежат {Молот|молот} и {Клещи|клещи}.';
};

obj {
nam = 'Молот';
inv = 'Заурядный плотницкий молоток.';
tak = function(s)
        _'Лежалово'.dsc = 'На нём лежат {Клещи|клещи}.'
        if have 'Клещи' then remove 'Лежалово' end
        return 'Вы берёте молот.';
       end;
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'У вас нет идей, как их соединить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Не получается.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                pn 'Бесполезно.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вы не видите смысла мыть молоток.'
            elseif w^'Веретено' then
                pn 'Не соединяются.'
            elseif w^'Клещи' then
                pn 'Вы громко ударяете клещами по молоту.'
                makeSound('Лязг', 'Из кувшина вырывается резкий металлический лязг.')
                if here().soundReact then here():soundReact('Лязг') end
                --_'Лик':change()
            elseif w^'Гвоздь' then
                pn 'Можно что-нибудь сколотить.'
            elseif w^'Доски' then
                pn 'Не получается.'
            elseif w^'Крест' then
                pn 'Не получается.'
            elseif w^'Слеза' then
                pn 'У вас нет идей, как их соединить.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'Клещи';
inv = 'Обычные металлические клещи.';
tak = function(s)
        _'Лежалово'.dsc = 'На нём лежит {Молот|молот}.'
        if have 'Молот' then remove 'Лежалово' end
        return 'Вы берёте клещи.';
       end;
used = function(s,w)
            if w^'Молот' then
                pn 'Вы громко ударяете молотом по клещам.'
                makeSound('Лязг', 'Из кувшина вырывается резкий металлический лязг.')
                if here().soundReact then here():soundReact('Лязг') end
                --_'Лик':change()
            elseif w^'Цепь с крюком' then
                pn 'У вас нет идей, как их соединить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Не получилось.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                pn 'У вас нет идей, как их соединить.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Можно было бы ополоснуть клещи, но не похоже, чтобы они в этом нуждались.'
            elseif w^'Веретено' then
                pn 'У вас нет идей, как их соединить.'
            elseif w^'Гвоздь' then
                pn 'Не получается.'
            elseif w^'Доски' then
                pn 'Бесполезно.'
            elseif w^'Крест' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end;
};

obj {
dsc = 'Три массивные двери закрывают проходы в соседние комнаты.';
};

obj_1p {
nam = 'Про двери';
dsc = 'Ни ручек, ни замков на них, только контур большого, в человеческий рост {креста} украшает каждый из проёмов.';
act_1 = 'Ожидаемо. Почти в каждом сне можно найти крест. Все ныряльщики твердят об этом как один. Если нет креста, значит есть квадрат.';
};

obj_1p {
dsc = 'По углам, чуть выше уровня глаз, из стен торчат человеческие кисти.';
act_1 = 'Выглядят неживыми';
};

obj {
nam = 'Северо-западная рука';
dsc = 'Та, что расположена на {северо-западе}';
act = function(s)
        pn 'Вы слегка шевелите цепь. Раздается металлический звон.'
        makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
        end;
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'У этой руки уже есть одна.'
            elseif string.match(w.nam,'Вес%d') then
                return false
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Мыть цепь ни к чему.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы слегка ударяете молотом по цепи. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Клещи' then
                pn 'Вы слегка беспокоите цепь клещами. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'Северо-восточная рука';
dsc = ', сжимает {$w|же`лез`ную} цепь с тупым крюком. Ещё две такие же держат руки на {северо-востоке}';
act = function(s)
        pn 'Вы слегка шевелите цепь. Раздается металлический звон.'
        makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
        end;
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'У этой руки уже есть одна.'
            elseif string.match(w.nam,'Вес%d') then
                return false
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Мыть цепь ни к чему.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы слегка ударяете молотом по цепи. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Клещи' then
                pn 'Вы слегка беспокоите цепь клещами. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'Юго-западная рука';
dsc = 'и {юго-западе}.';
act = function(s)
        pn 'Вы слегка шевелите цепь. Раздается металлический звон.'
        makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
        end;
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'У этой руки уже есть одна.'
            elseif string.match(w.nam,'Вес%d') then
                return false
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Мыть цепь ни к чему.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы слегка ударяете молотом по цепи. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Клещи' then
                pn 'Вы слегка беспокоите цепь клещами. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'РукаПрибита';
dsc = 'Ладонь на {юго-востоке} прибита к стене большим {Гвоздь|гвоздём}. Цепи у неё нет.';
act = 'Вы осторожно прикасаетесь к ладони, она слегка шевелится в ответ.';
used = function(s,w)
            if w^'Цепь с крюком' then
                return false
            elseif string.match(w.nam,'Вес%d') then
                return false
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                pn 'Руке это не нужно.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вода ей вряд ли поможет.'
            elseif w^'Веретено' then
                pn 'Руке это не интересно.'
            elseif w^'Молот' then
                pn 'Ей и без этого достаточно плохо.'
            elseif w^'Клещи' then
                pn 'Рука не сможет вытащить гвоздь сама.'
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                pn 'Ей это не интересно.'
            elseif w^'Крест' then
                pn 'Ей это не интересно.'
            elseif w^'Слеза' then
                pn 'Ей это не интересно.'
            else
                return false
                --pn 'Ничего хорошего не получилось.'
            end -- if
        end; --func
}:with{
obj {
nam = 'Гвоздь';
act = 'Руками не вытащить.';
used = function(s,w)
            if w^'Клещи' and have('Гвоздь') then
                            pn 'Можно попробовать откусить шляпку, но это приведёт его в негодность.'
            elseif w^'Клещи' then   
                            take 'Гвоздь'
                            pn 'Вы вытаскиваете гвоздь. Рука оживает и делает несколько сжимающих движений. После чего машет туда-сюда, словно приветствует вас и протягивает вам какой-то предмет.'
                            take 'Вес1'
                            replace('РукаПрибита', 'Активная рука')
                            return true
            elseif w^'Цепь с крюком' then
                pn 'У вас нет идей, как их соединить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Не получилось.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                pn 'Ничего хорошего не вышло'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вы не видите смысла мыть гвоздь.'
            elseif w^'Веретено' then
                pn 'Ничего не вышло.'
            elseif w^'Молот' and have('Гвоздь') then
                pn 'Можно что-нибудь сколотить.'
            elseif w^'Молот' then
                pn 'Вбить гвоздь до конца? Мысль понятная, но негуманная.'
            elseif w^'Доски' then
                pn 'Логичнее наоборот.'
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end;
}
};

} -- Конец предметов в зале


obj {
nam = 'Активная рука';
dsc = '^Вы освободили {руку} от заключения и теперь она слегка шевелит пальцами.';
act = function(s)
    if inspect('Помост') then 
        return 'Ладонь отвечает на ваше рукопожатие, а затем по очереди показывает пальцем на три закрытые двери и помост в центре.'
    elseif not inspect('Помост') and _'КрестРаб'.dry then
        if have('Кувшин') then return 'Ладонь отвечает на рукопожатие и указывает на середину комнаты и что-то в ваших руках.'
                          else return 'Ладонь отвечает на рукопожатие и делает волнообразный жест сверху вниз.'
                          end
    elseif _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик перекошенный' then
        return 'Ладонь отвечает на ваше рукопожатие и демонстрирует жест, словно бьёт кулаком по чему-то сверху вниз.'
    elseif #_'Лик'.changeList<4 then
        return 'Ладонь отвечает на ваше рукопожатие и сжимается в кулак. Вам кажется, что внутри него есть что-то, но ладонь раскрывается и демонстрирует вам пустоту.'
    elseif _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик плачущий' and _'Колокол'.needTear then
        return 'Ладонь отвечает на ваше рукопожатие и указывает пальцем в коридор.'
    elseif not inspect('Вес5') or not inspect('Вес4') or (not inspect('Вес10') and not inspect('Вес2_1')) or not inspect('Цепь с крюком') then
        if _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик спокойный' and _'Лик спокойный'.stage == 3 then return 'Ладонь сжимается в кулак, секунду трясется мелкой дрожью и резко раскрывается.' end
        if _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик разбитый' then return 'Ладонь сжимается в кулак, секунду трясется мелкой дрожью и резко раскрывается.' end
        if _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик изнеможденный' and _'Лик изнеможденный'.done then return 'Ладонь сжимается в кулак, секунду трясется мелкой дрожью и резко раскрывается.' end
        if _'Лик'.changeList[_'Лик'.changeCurrent]=='Лик плачущий' and _'Лик плачущий'.done then return 'Ладонь сжимается в кулак, секунду трясется мелкой дрожью и резко раскрывается.' end
        if _'КрестРаб'.direction == 'к западу' then return 'Ладонь отвечает на ваше рукопожатие и указывает пальцем на крест в центре зала.' end
        return 'Ладонь отвечает на ваше рукопожатие и указывает пальцем на открытую комнату.'
    else 
        return 'Ладонь отвечает на ваше рукопожатие, после чего показывает большим пальцем наверх и делает непонятный жест — словно бы солит что-то — но при этом её пальцы направлены не вниз, а вверх.'
    end --if
    end; -- func
used = function(s,w)
            if w^'Цепь с крюком' then 
                remove('Цепь с крюком')
                replace(s, _'Юго-восточная рука')
                pn 'Вы вручаете руке цепь с крюком.'
            elseif string.match(w.nam,'Вес%d') then
                pn('Рука принимает у вас грузик, взвешивает его на ладони, возвращает вам и показывает пальцами цифру '..w.weight..'.')
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then
                p 'Рука приоткрывает крышку кувшина.' 
                pn(w.soundtext)
                if here().soundReact then here():soundReact(s.sound) end
                w.sound = ''
                w.soundtext = ''
                return true
            elseif w^'Кувшин' and not _'Кувшин'.withwater and _'Кувшин'.withpearl then
                pn 'Рука залезает в протянутый кувшин и достаёт из него жемчужину.'
                _'Кувшин'.withpearl = false
                bpearlFound()
            elseif w^'Кувшин' and _'Кувшин'.withwater then
                pn 'Рука залезает в протянутый кувшин и плескается внутри какое-то время.'
            elseif w^'Веретено' then
                pn 'Рука взвешивает веретено, ощупывает его пальцами, возвращает вам и показывает большой палец.'
            elseif w^'Молот' then
                pn 'Рука выглядит дружелюбной, но не стоит испытывать её терпение.'
            elseif w^'Клещи' then
                pn 'Рука выглядит дружелюбной, но не стоит испытывать её терпение.'
            elseif w^'Гвоздь' then
                pn 'Рука категорически отказывается брать это.'
            elseif w^'Доски' then
                pn 'Рука прикасается к доске и перекрещивает указательный палец со средним.'
            elseif w^'Крест' then
                pn 'Едва прикоснувшись к кресту рука отдёргивается назад и указывает пальцем в центр комнаты.'
            elseif w^'Слеза' then
                pn 'Рука принимает кристалл, взвешивает его на ладони и возвращает вам.'
            else
                pn 'Рука не желает брать эту штуку.'
            end
        end;
}

obj {
nam = 'Юго-восточная рука';
dsc = 'Рука на {юго-востоке} теперь тоже держит железную цепь и с виду ничем не отличается от остальных.';
act = function(s)
        pn 'Вы забираете у руки все, что она держит.'
        -- Эта штука не работает, видимо take мешает for_each динамически меняя s.obj
        -- s.obj:for_each( function(ss) dprint(ss) if ss~=nil then take(ss) end end )
        local temp = {}
        s.obj:for_each( function(ss) table.insert(temp, ss) end )
        for i = 1, #temp do
            take(temp[i])
        end --for
        take 'Цепь с крюком'
        replace(s, _'Активная рука')
        end;
used = function(s,w)
            if w^'Цепь с крюком' then
                return false
            elseif string.match(w.nam,'Вес%d') then
                return false
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Мыть цепь ни к чему.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы слегка ударяете молотом по цепи. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Клещи' then
                pn 'Вы слегка беспокоите цепь клещами. Раздается металлический звон.'
                makeSound('Лязг цепей','Из кувшина вырывается лязг цепей.')
            elseif w^'Гвоздь' then
                return false
            elseif w^'Доски' then
                return false
            elseif w^'Крест' then
                return false
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
};

obj {
nam = 'КрестРаб';
direction = 'к западу';
dry = true;
dsc = function(s)
        return 'Точно в центре средокрестья на деревянном помосте вертикально стоит {крест}. Сейчас он повёрнут '..s.direction..'.';
        end; 
act = function(s)
        if s.dry then
                    pn 'Вы пытаетесь повернуть крест, но он недостаточно плотно сидит в пазе и шатается.'
                    return true
                    end
        pn 'С мерзким скрипом вы поворачиваете крест по часовой стрелке. Со всех сторон на вас обрушиваются невыразительные звуки, словно за закрытыми дверями что-то происходит. Дверь расположенная напротив креста открывается.'
        makeSound('Скрип', 'Из кувшина вырывается скрип.')
        if s.direction=='к западу' then
            s.direction='к северу'
            _'П Северная комната':open()
            if where('Веретено')^'Северная комната закрытая' then place('Веретено', _'П Северная комната'.walk) end
            if where('Кувшин')^'Северная комната закрытая' then place('Кувшин', _'П Северная комната'.walk) end
        elseif s.direction=='к северу' then
            s.direction='к востоку'
            _'П Восточная комната':open()
            _'П Северная комната':close()
            if where('Веретено')^'Восточная комната закрытая' then place('Веретено', _'П Восточная комната'.walk) end
            if where('Кувшин')^'Восточная комната закрытая' then place('Кувшин', _'П Восточная комната'.walk) end
            if where('Веретено')^(_'П Северная комната'.walk) then place('Веретено', 'Северная комната закрытая') end
            if where('Кувшин')^(_'П Северная комната'.walk) then place('Кувшин', 'Северная комната закрытая') end
        elseif s.direction=='к востоку' then
            s.direction='к югу'
            _'П Южная комната':open()
            _'П Восточная комната':close()
            if where('Веретено')^'Южная комната закрытая' then place('Веретено', _'П Южная комната'.walk) end
            if where('Кувшин')^'Южная комната закрытая' then place('Кувшин', _'П Южная комната'.walk) end
            if where('Веретено')^(_'П Восточная комната'.walk) then place('Веретено', 'Восточная комната закрытая') end
            if where('Кувшин')^(_'П Восточная комната'.walk) then place('Кувшин', 'Восточная комната закрытая') end
        elseif s.direction=='к югу' then
            s.direction='к западу'
            _'П Южная комната':close()
            if where('Веретено')^(_'П Южная комната'.walk) then place('Веретено', 'Южная комната закрытая') end
            if where('Кувшин')^(_'П Южная комната'.walk) then place('Кувшин', 'Южная комната закрытая') end
        end
        return true
        end;
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'Ничего хорошего не получилось.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Здесь это не закрепить.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Вы обильно смачиваете основание креста водой, чтобы он крепче сидел в пазу.'
                s.dry = false
            elseif w^'Веретено' then
                pn 'Не получилось'
            elseif w^'Молот' then
                pn 'Вы тихонько ударяете молотом по кресту, порождая деревянный стук.'
                makeSound('Стук','Из кувшина вырывается деревянный стук.')
            elseif w^'Клещи' then
                pn 'Вам не нравится идея разбирать крест. Он может ещё пригодиться.'
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
        end; --func
}:with{}
