--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.

obj {
nam = 'Кувшин';
withwater = false;
withpearl = true;
sound = '';
soundtext = '';
dsc = function(s)
        if s.sound~='' then return '^Здесь стоит {кувшин}, его крышка закрыта.'
                    else return '^Здесь стоит {кувшин}, его крышка открыта.'
                    end;
        end;
introShowed = false;
tak = function(s)
        if  not s.introShowed and s.sound~='' then --При первом поднятии показываем игроку звук
                        p 'Вы поднимаете кувшин и нечаянно приоткрываете его крышку.'
                        pn(s.soundtext)
                        if here().soundReact then here():soundReact(s.sound) end
                        s.sound = ''
                        s.soundtext = ''
                        s.introShowed = true
                        return true                
                    else
                        return 'Вы забираете кувшин.'  
                    end -- if
      end; -- func
inv = function(s)
        -- Если внутри есть звук - выпускаем
        if s.sound~=''   then
                        -- Здесь будут действия, зависящие от комнаты
                        p 'Вы приоткрываете крышку.'
                        pn(s.soundtext)
                        if here().soundReact then here():soundReact(s.sound) end
                        s.sound = ''
                        s.soundtext = ''
                        return true
                        end
        -- Если мы хотим поставить под дождь - набираем воду и заполняем звуком дождя
        if here()^'Снаружи' and isRain() then
                                                place('Кувшин')
                                                s.withwater = true
                                                s.sound = 'Дождь'
                                                s.soundtext = 'Из кувшина вырывается звук дождя.'
                                                return 'Вы ставите кувшин на землю. Его крышка все время норовит закрыться, поэтому вы слегка придерживаете её рукой, чтобы дать кувшину наполниться дождём.'
                                                end
        -- Если ставим, где слышен стук дождя -- наполняем стуком дождя
        if seen('Шум дождя') then
                                                place('Кувшин')
                                                s.sound = 'Шум дождя'
                                                s.soundtext = 'Из кувшина вырывается стук дождя по крыше.'
                                                return 'Вы ставите кувшин на пол. Его крышка немедленно захлопывается сама собой.'
                                                end
        -- Если ставим, где слышен звук капель -- наполняем звуком капель
        if where('Звук капель')^here() then
                                                place('Кувшин')
                                                s.sound = 'Звук капель'
                                                s.soundtext = 'Из кувшина вырывается звук капающей воды.'
                                                return 'Вы ставите кувшин на пол. Его крышка немедленно захлопывается сама собой.'
                                                end
        -- Если ставим в закрытой южной комнате -- активация комнаты
        if here()^'Южная комната закрытая' then
                                                pn('Вы ставите кувшин на пол и открываете крышку. Сперва кажется, что ничего не происходит, но через пару секунд вы замечаете, что стон стал тише. Проходит ещё полминуты и крышка захлопывается сама собой. Раздаётся звук, словно кто-то тяжело выдохнул, за которым следует {$w|уми`ро`тво`рён`ная} тишина.')
                                                remove 'Стон'

                                                _'П Южная комната'.walk='Южная комната активированная'
                                                --if where('Веретено')^'Южная комната' then place('Веретено','Южная комната активированная') end
                                                --if where('Кувшин')^'Южная комната' then place('Кувшин','Южная комната активированная') end
                                                addFace('Лик изнеможденный')
                                                --walk 'Южная комната активированная'

                                                place('Кувшин')
                                                s.sound = 'Стон'
                                                s.soundtext = 'Тихий протяжный стон доносится изнутри кувшина.'
                                                return true
                                                end
        -- Наконец, если никаких постоянных звуков нет, кувшин должен стоять и ждать их
        place('Кувшин')
        return 'Вы ставите кувшин на землю и открываете крышку.'
        end; -- function
used = function(s,w)
            if s.sound~='' then return 'Внутри заперт звук. Стоит выпустить его, прежде чем делать с кувшином что-либо.' end
            
            if w^'Цепь с крюком' then
                pn 'Вы опускаете крюк в кувшин. Замечательно входит и выходит.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Этому не место в кувшине.'
            elseif w^'Веретено' then
                pn 'Этому не место в кувшине.'
            elseif w^'Молот' then
                pn 'Вы осторожно, так чтобы не разбить, стучите молотом по кувшину.'
                makeSound('Глухой стук','Из кувшина доносится тихий глухой звук, словно кто-то постучал по нему.')
                if here().soundReact then here():soundReact('Глухой стук') end
            elseif w^'Клещи' then
                pn 'Вы опускаете клещи в кувшин и пытаетесь нащупать там что-нибудь. Бесполезно.'
            elseif w^'Гвоздь' then
                pn 'Этому не место в кувшине.'
            elseif w^'Доски' then
                pn 'Это не поместится внутри.'
            elseif w^'Крест' then
                pn 'Это не поместится внутри.'
            elseif w^'Слеза' then
                pn 'Этому не место в кувшине.'
            else
                return false
            end -- if
        end; --func
}

-- Помещает заданный звук в кувшин
makeSound = function(soundName, openText)
            if where('Кувшин')==here() and _'Кувшин'.sound=='' 
                             then  
                             _'Кувшин'.sound = soundName
                             _'Кувшин'.soundtext = openText
                             pn 'Вы замечаете, что крышка кувшина захлопнулась.'
                             end
        end;

