--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.

obj {
nam = 'Проход наружу';
dsc = 'В одном из углов {стена} кажется неплотной, она слегка колышется, словно ткань на ветру.';
speach = {'Здесь нельзя!'; 'Вон!'; 'Прочь!'; 'Уйди!'; 'Не хочу!'; 'Оставь!'; 'Нет!'; 'Никогда!'};
act = function(s)
        pn('Вы прикасаетесь к стене и вас резко всасывает в неё и выбрасывает наружу. ^"'..s.speach[rnd(#s.speach)]..'", — слышите вы голос в голове.')
        walk 'Снаружи'
        end;
withpearl = true;
used = function(s,w)
        if w^'Слеза' and s.withpearl then
                pn 'Вы бросаете кристалл в неплотность. Ударившись о неё он словно разделяется на две части, одна из которых отскакивает назад и падает вам под ноги. Вы поднимаете с пола маленькую чёрную жемчужину.'
                s.withpearl = false
                place('Слеза', 'Снаружи')
                bpearlFound()
        elseif w^'Слеза' and not s.withpearl then
                pn 'Вы бросаете кристалл в неплотность и он исчезает в стене.'
                place('Слеза', 'Снаружи')
        elseif w^'Веретено' then
                pn 'Вы кидаете веретено в неплотность и оно исчезает в стене. Его чёрная тень словно забывает последовать за ним и падает на пол вам под ноги.'
                replace('Веретено', 'Крутиться...')
                place('Веретено', 'Снаружи')
        elseif w^'Молот' then
                pn 'Эта вещь вам может ещё пригодиться.'
        elseif w^'Клещи' then 
                pn 'Эта вещь вам может ещё пригодиться.'
        elseif w^'Цепь с крюком' then
                pn 'Вы пытаетесь подцепить крюком колыхающуюся поверхность стены, но у вас ничего не получается.'
        elseif string.match(w.nam,'Вес%d') then
                pn 'Опыт подсказывает вам, что эту штуку лучше не терять.'
        elseif w^'Кувшин' then
                pn 'Вы отказываетесь от мысли кидать кувшин в стену. Вдруг разобъётся?'
        else
                pn 'Вам не по душе эта идея.'
        end --if
        end;
};


room {
nam = 'Северная комната';
pic = 'img/north'..picext;
way = {path{'В зал','Зал'}};
soundReact = function(s, sound)
                if sound == 'Звук капель' then
                    pn('Кувшин умолкает и в комнате повисает противоестественная тишина. Новая. Не та, что была до этого. Комната словно обдумывает звук. И вслед за тишиной слева, справа, со всех сторон как запоздалое эхо от стен звук повторяется раз за разом: громче, тише, быстрее, медленнее, другим тембром и тоном. Внезапно становится светлее. Вы поднимаете голову и видите несколько свечей под потолком, которые то ли зажглись сами собой, то ли вовсе появились из ниоткуда. Лицо на стене меняется, теперь оно выступает из стены барельефом, на нём играют тени. Оно пристально смотрит прямо в глаза. Вы ощущаете напряжение в чертах, но не можете разобрать, что оно значит. Наконец, глаза закрываются и лицо принимает злое выражение. Вы ждёте ещё какое-то время, но больше ничего не происходит.')
                    _'П Северная комната'.walk='Северная комната активированная'
                    if where('Веретено')^'Северная комната' then place('Веретено','Северная комната активированная') end
                    if where('Кувшин')^'Северная комната' then place('Кувшин','Северная комната активированная') end
                    addFace('Лик озлобленный')
                    walk 'Северная комната активированная'
                else
                    pn('Образ на стене едва заметно шевелится, словно прислушивается. Но больше ничего не происходит, похоже, это не тот звук, что он ждёт.')
                end -- if
              end; -- func

}:with{

obj_1p {
dsc = 'В комнате сыро. Пол выглядит так, словно его недавно мыли. Боковые стены снизу доверху изрисованы маленькими значками капель. Напротив входа вы с трудом различаете рисунок углём: женское лицо, точнее контур, лишённый каких либо черт. Ни глаз, ни рта, ни носа. Рука, едва обозначенная несколькими линиями, касается уха "домиком".';
act_1 = '';
};

} -- Конец предметов открытой комнаты





room {
nam = 'Северная комната закрытая';
pic = 'img/north_close'..picext;
disp = 'Северная комната';
soundReact = function(s, sound)
                if sound == 'Звук капель' then
                    pn('Вы понимаете, что это тот самый звук, что живёт здесь. Кувшин поёт с комнатой в унисон, вы всё сделали правильно. Почти. Надо исправить только одну деталь.')
                    else
                    pn('Вы понимаете, что это не тот звук, что живёт в этой комнате.')
                    end -- if
              end; -- func
}:with{
obj {
dsc = 'В этой комнате ничего нет. Совсем. Одни голые стены и ровный, ничем не {$w|при`ме`ча`тель`ный} пол. И тишина. Вы задерживаете дыхание и на пределе слышимости разбираете звук: словно капли бьют одна за другой по воде. Вы не уверены до конца, не чудится ли вам.';
};

'Проход наружу';

} -- Конец предметов закрытой комнаты



room {
nam = 'Северная комната активированная';
disp = 'Северная комната';
pic = 'img/face'..picext;
soundReact = function(s, sound) -- Необходимо активировать изменение лица при выпускании громких звуков из кувшина
                if sound == 'Колокол' or sound == 'Лязг' or sound == 'Стук' or sound == 'Вопль' then
                       _'Лик':change()
                end --if
              end; -- func
way = {path{'В зал','Зал'}};
}:with{
obj {
dsc = 'В комнате ничего нет. Пахнет болотом. Над входом, почти под самым потолком горят три свечи. Рисунков на стенах больше нет, а сами они испещрены {$w|вер`ти`каль`ны`ми} неровными полосами.';
};
'Лик';
} -- Конец предметов активированной комнаты
