--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.

room {
nam = 'Снаружи';
pic = 'img/outside'..picext;
way = {path{'В дом', 'Западный коридор'}};
}:with{

obj_1p {
dsc = 'Сумрачный пятачок реальности посреди {чёрного Ничто}.';
act_1 = 'Не лезь в темноту. Так звучит первое правило ныряльщика. Темнота — это больше чем неизвестность, темнота во сне живая, плотная и не желает иметь с тобой дела. Точнее все её дела с тобой закончились, когда она выплюнула тебя сюда. Вернуться в темноту — привилегия, которую ты должен заслужить. Но даже когда ты уже не с пустыми руками — всё равно. Не лезь в темноту. Она сама заберёт тебя, когда сочтёт необходимым.';
used = function(s,w)
         return 'Не стоит туда соваться.'
        end; --func
};

obj_1p {
dsc = '{Дом} в форме креста занимает центр этой пустоты, словно знак на карте, которым отмечен клад. Окон нет, стены плоские и прямые. Выглядит уродливо и бедно, как деревянная лачуга. Внутрь ведёт тяжёлая дверь без замка.';
act_1 = 'Дом — это сам человек. Войти внутрь значит погрузиться в чью-то душу. Если повезёт — в свою. Если нет... в чужой душе может разверзнуться ад, ибо во сне человек даже хуже, чем в жизни.';
used = function(s,w)
         return 'Из этого ничего не выйдет.'
        end; --func
};

obj {
nam = 'Колокол';
dsc = 'Рядом с домом воткнут ребром в землю большой {колокол} в человеческий рост высотою.';
washed = false;
needTear = true;
used = function(s,w)
        if w^'Молот' then
                    p 'Вы бьёте по колоколу.'
                    makeSound('Колокол', 'Из кувшина вырывается протяжный стон колокола.')
                    if isRain() then 
                                place('Дождь', 'temp')
                                place('Шум дождя', 'temp')
                                place('Звук капель', 'Западный коридор')
                                _'Звук капель'.count = _'Звук капель'.maxcount
                                lifeon('Звук капель')
                                p 'Дождь прекращается.'
                                return true
                            else 
                                place('Дождь')
                                put('Шум дождя', 'Восточная комната')
                                put('Шум дождя', 'Восточная комната закрытая')
                                put('Шум дождя', 'Восточная комната активированная')
                                put('Шум дождя', 'Северная комната')
                                put('Шум дождя', 'Северная комната закрытая')
                                put('Шум дождя', 'Северная комната активированная')
                                put('Шум дождя', 'Южная комната')
                                put('Шум дождя', 'Южная комната закрытая')
                                put('Шум дождя', 'Южная комната активированная')
                                put('Шум дождя', 'Западный коридор')
                                put('Шум дождя', 'Западный коридор финал')
                                put('Шум дождя', 'Зал')
                                put('Шум дождя', 'Зал_финал')
                                place('Звук капель', 'temp')
                                lifeoff('Звук капель')
                                p 'Начинается дождь.'
                                return true
                            end
        elseif w^'Кувшин' and _'Кувшин'.sound~='' then
                                pn 'Вы наклоняете кувшин внутрь колокола и приоктрываете крышку.'
                                pn(w.soundtext)
                                if w.sound == 'Стон' then
                                    pn 'Колокол звучит в унисон, громче и громче. Вы видите, как его поверхность дрожит всё сильнее по мере того, как звук из кувшина ослабевает. Сверху что-то сыпется: не то грязь, не то пепел. Вы погружаете руку внутрь этой трухи и нащупываете жемчужину.'
                                    bpearlFound()
                                else
                                    pn 'Колокол слегка дрожит от гулкого звука.'
                                end
                                w.sound = ''
                                w.soundtext = ''
        elseif w^'Кувшин' and _'Кувшин'.withwater then
                                if s.washed then return 'Мыть колокол второй раз нет необходимости.' end
                                pn 'Вы смываете грязь с поверхности колокола водой из кувшина и находите под ней россыпь голубых кристаллов в форме капель.'
                                s.washed = true
                                s.act = 'Поверхность колокола инкрустирована голубыми кристаллами в форме капель.'
        elseif (w^'Веретено' or w^'Гвоздь') and s.washed and s.needTear  then
                                pn 'Вам удается поддеть и вытащить один из кристаллов.'
                                take 'Слеза'
                                s.needTear = false
        elseif (w^'Веретено' or w^'Гвоздь' or w^'Клещи') and not s.needTear then
                                pn 'Одного кристалла вам достаточно.' 
        elseif w^'Цепь с крюком' then
                                pn 'У вас нет идей, как их соединить.'
        elseif string.match(w.nam,'Вес%d') then
                                pn 'Бесполезно.'
        elseif w^'Веретено' then
                                pn 'У вас нет идей, как их совместить.'
        elseif w^'Клещи' then
                                pn 'Не получается.'
        elseif w^'Гвоздь' then
                                pn 'У вас нет идей, как их совместить.'
        elseif w^'Доски' then
                                pn 'Ничего хорошего не получилось.'
        elseif w^'Крест' then
                                pn 'Ничего хорошего не получилось.'
        elseif w^'Слеза' then
                                pn 'Не для того вы его вытащили, чтобы вставлять обратно.'
        else
                                pn 'Ничего хорошего не получилось.'
        end -- if
        end; --func
act = 'Колокол весь вымазан в грязи. Вы осторожно заглядываете внутрь: как ни странно, там не темнее, чем снаружи. Языка нигде нет. Онемевший глашатай печально привалился к земле.';
};

} -- Конец объектов снаружи

-- Эта техническая комната нужна, потому что на нигде не расположенный объект ругается where
room {nam='temp'}:with{
obj {
nam = 'Дождь';
dsc = '^Противный холодный дождь льёт из темноты сверху в темноту снизу.';
};
obj {
nam = 'Шум дождя';
dsc = '^Вы слышите стук дождя по крыше дома.';
};
obj {
nam = 'Звук капель';
dsc = '^Вы слышите, как где-то капает вода, скопившаяся после дождя.';
maxcount = 10;
count = 10;
life = function(s)
    s.count = s.count - 1
    if s.count < 0 then
                    place(s, 'temp')
                    s.count = s.maxcount
                    lifeoff(s)
                    end
    end;
};
}

function isRain()
if where('Дождь')^'Снаружи' then return true 
                            else return false
                            end
end


obj {
nam = 'Слеза';
disp = 'Кристалл';
inv = 'Голубой полупрозрачный кристалл в форме капли. Это не жемчужина, хотя и похож.';
dsc = '^На земле лежит маленький голубой {кристалл} в форме капли.';
tak = 'Вы подбираете кристалл.';
used = function(s,w)
            if w^'Цепь с крюком' then
                pn 'У вас нет идей, как их соединить.'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Не похоже, чтобы они соединялись.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Кристалл и так сверкает как слеза.'
            elseif w^'Веретено' then
                pn 'Вам жаль царапать кристалл.'
            elseif w^'Молот' then
                pn 'Вам жалко разбивать кристалл.'
            elseif w^'Клещи' then
                pn 'Вам жалко разбивать кристалл.'
            elseif w^'Гвоздь' then
                pn 'Вам жаль царапать кристалл.'
            elseif w^'Доски' then
                pn 'Ничего не вышло.'
            elseif w^'Крест' then
                pn 'Не получается.'
            else
                return false
            end -- if
        end; --func
}
