--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.

function weightUsed(s,w)
            if w^'Цепь с крюком' then
                pn 'Можно подцепить грузик крюком, но что дальше?'
            elseif string.match(w.nam,'Вес%d') then
                pn 'Похожи как братья.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then -- Без воды без звука
                return false
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Мыть грузик у вас нет ни желания, ни необходимости.'
            elseif w^'Веретено' then
                pn 'Не соединяются.'
            elseif w^'Молот' then
                pn 'Тут молотом ничего не сделаешь.'
            elseif w^'Клещи' then
                pn 'Не разбирается.'
            elseif w^'Гвоздь' then
                pn 'Ничего хорошего не вышло.'
            elseif w^'Доски' then
                pn 'У вас нет идей, как это совместить.'
            elseif w^'Крест' then
                pn 'У вас нет идей, как это совместить.'
            elseif w^'Слеза' then
                pn 'Не соединяется.'
            else
                return false
            end -- if
end -- func

function weightUse(s,w)
        if w^'Северо-западная рука' or w^'Северо-восточная рука' or 
           w^'Юго-западная рука' or w^'Юго-восточная рука' 
           then
                place(s,w)
                pn 'Вы вешаете груз на один из крюков. Цепь натягивается под его весом.'
                
                -- Тут проверка решения головоломки
                local handNW, handNE, handSE, handSW = 0, 0, 0, 0
                _'Северо-западная рука'.obj:for_each( function(s) handNW = handNW + s.weight end )
                _'Северо-восточная рука'.obj:for_each( function(s) handNE = handNE + s.weight end )
                _'Юго-западная рука'.obj:for_each( function(s) handSW = handSW + s.weight end )
                _'Юго-восточная рука'.obj:for_each( function(s) handSE = handSE + s.weight end )
                --dprint(handNW, handNE, handSE, handSW)
                if handNW==4 and handNE==5 and handSW==5 and handSE==6 then
                        xact.fwalk('Активация цепей')
                        if not have 'Веретено' then replace('Крутиться...','Веретено') end;
                        remove 'Кувшин'
                        end
           end
        end


------------ Дает изнеможденное лицо --------------------

obj {
nam = 'Вес5';
weight = 5;
disp = 'Большой груз';
dsc = '(подвешен большой {груз})';
tak = 'Вы снимаете груз с крюка.';
inv = 'Довольно увесистый кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

----------------- Отдает рука ----------------------------

obj {
nam = 'Вес1';
weight = 1;
disp = 'Крошечный груз';
dsc = '(подвешен крошечный {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Маленький кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

------------- Выдергивается из озлобленного лица --------------------------------

obj {
nam = 'Вес4';
weight = 4;
disp = 'Средний груз';
dsc = '(подвешен средний {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

------------ Дает плачущее лицо ---------------------------------

obj {
nam = 'Вес10';
weight = 10;
disp = 'Длинный груз';
dsc = '(подвешен длинный {груз})';
tak = 'Вы снимаете груз с крюка.';
inv = 'Длинный металлический стержень с петлёй на одном из концов. Тяжёлый. Четыре канавки разделяют его по длине на пять равных частей.';
use = weightUse;
used = function(s,w)
        if w^'Веретено' then
                    pn 'Вы пытаетесь разделить груз на части, но у вас не получается.'
        elseif w^'Клещи' and ( where(s)^'Юго-восточная рука' or 
                               where(s)^'Юго-западная рука' or
                               where(s)^'Северо-восточная рука'or
                               where(s)^'Северо-западная рука')
                    then
                    replace(s,'Вес2_1')
                    take('Вес2_2')
                    take('Вес2_3')
                    take('Вес2_4')
                    take('Вес2_5')
                    pn 'Ухватившись обоими руками за клещи и как следует дёрнув нижнюю часть груза вам удаётся разобрать стержень на пять меньших частей.'
        elseif w^'Клещи' then
                    pn 'Вы пытаетесь разделить груз на части, но вам не хватает силы сделать это на весу.'
        elseif w^'Молот' then
                pn 'Молотом тут не поможешь.'
        elseif w^'Кувшин' then
                    pn 'Стержень и так достаточно чистый.'
        else
                    pn 'Не получается.'
        end --if
        end;-- func;
}

obj {
nam = 'Вес2_1';
weight = 2;
disp = 'Маленький груз';
dsc = '(подвешен маленький {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

obj {
nam = 'Вес2_2';
weight = 2;
disp = 'Маленький груз';
dsc = '(подвешен маленький {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

obj {
nam = 'Вес2_3';
weight = 2;
disp = 'Маленький груз';
dsc = '(подвешен маленький {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

obj {
nam = 'Вес2_4';
weight = 2;
disp = 'Маленький груз';
dsc = '(подвешен маленький {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}

obj {
nam = 'Вес2_5';
weight = 2;
disp = 'Маленький груз';
dsc = '(подвешен маленький {грузик})';
tak = 'Вы снимаете грузик с крюка.';
inv = 'Небольшой кусок металла с петлёй.';
use = weightUse;
used = weightUsed;
}
