--    Ныряльщик/The Diver
--    Copyright (C) 2024  Luka (ot-luki@yandex.ru)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <https://www.gnu.org/licenses/>.


room {
nam = 'Западный коридор';
    pic = 'img/west'..picext;
way = {path{'Наружу', 'Снаружи'}, path{'В зал', 'Зал'}};
}:with{

obj_1p {
dsc = 'Вытянутый тёмный коридор идёт {с запада на восток} и заканчивается чёрным провалом дверного косяка. Большая свеча горит почти под самым потолком.';
act_1 = [[Сон всегда ориентирован по четырём сторонам. Никто не знает почему, но ныряльщик безошибочно чувствует, где север. Это так же легко и естественно, как отличать верх от низа. И так же сложно объяснить словами.^
Иногда это важно. Ты обычно приходишь в сон с запада. Наверно, это что-то значит. Поэтому, если сомневаешься, куда идти — иди на восток, скорее всего именно там центр сна.]];
used = function(s,w)
         return 'Ничего хорошего не получилось.'
        end; --func
};

obj_1p {
dsc = 'Благодаря ей можно различить квадратную табличку с {надписью}, висящую прямо над проёмом.';
act_1 = [[Вы несколько секунд пристально всматриваетесь в буквы. Глупая привычка. Всякий знает: во сне невозможно читать, слова расплываются, превращаются в бессмысленный набор непонятных значков.^
Но у ныряльщиков свои мифы и приметы. Говорят, если получится прочесть надпись, там будет подсказка как войти в Белый Сон. У кого ни спроси, любой скажет, что это сказки, что Белого Сна не бывает, а ни одной надписи ещё никому не удалось прочесть. Но как не попытаться, когда никто не увидит?]];
used = function(s,w)
         return 'Как ни бейся — не прочесть.'
        end; --func
};

obj_1p {
dsc = 'Узкие, вытянутые вверх {окна} впитывают в себя скудный свет.';
act_1 = 'Вы внимательнее изучаете окна и понимаете, что они ненастоящие. Стена не прорезана до конца и закрыта в глубине доской, на которой грубо тёмными красками нарисован мрачный пейзаж.';
used = function(s,w)
         return 'С этим ничего нельзя сделать.'
        end; --func
};

obj {
nam = 'Яма';
dsc = 'У входа расположена {яма}, закрытая массивной железной решёткой.';
act = 'Кажется, в глубине лежат несколько досок, но руками до них не дотянуться.';
haveWood = true;
used = function(s,w)
            if w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                                                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and _'Кувшин'.withwater and s.haveWood then 
                                                pn 'Вы наполняете из кувшина яму водой. Доски всплывают и теперь вы можете до них дотянуться.'
                                                s.act = 'Яма заполнена водой.'
                                                place 'Доски' 
                                                s.haveWood = false
                                                return true
            elseif w^'Кувшин' and _'Кувшин'.withwater and not s.haveWood then 
                                                pn 'Продолжать бессмысленно.'
            elseif w^'Кувшин' and not _'Кувшин'.withwater then 
                                                pn 'До дна не дотянуться.'
            elseif w^'Цепь с крюком' then
                                                pn 'Там нет ничего, что можно было бы зацепить крюком.'
            elseif string.match(w.nam,'Вес%d') then
                                                pn 'А вдруг он понадобится?'
            elseif w^'Веретено' then
                                                pn 'У вас есть опасения, что вы не сможете потом выбраться наружу.'
            elseif w^'Молот' then
                                                pn 'Вы несколько раз сильно ударяете по решётке. Не похоже, что так с ней можно что-то сделать.'
                                                makeSound('МеталлМеталл','Из кувшина вырывается грохот удара металлом по металлу.')
            elseif w^'Клещи' then
                                                pn 'Вы пытаетесь отогнуть решётку клещами, но сил не хватает.'
            elseif w^'Гвоздь' then
                                                pn 'Не стоит выбрасывать гвоздь просто так, вдруг пригодится.'
            elseif w^'Доски' then
                                                pn 'Достали, теперь придётся с собой носить.'
            elseif w^'Крест' then
                                                pn 'Это не пролезет сквозь решётку.'
            elseif w^'Слеза' then
                                                pn 'Не стоит пока выбрасывать, вдруг пригодится.'
            else
                return false
            end -- if
        end; -- func
};
'Кувшин'
} -- end with

obj {
nam = 'Доски';
inv = 'Пара больших деревянных досок.';
dsc = '^В яме плавает {пара досок}.';
tak = 'Вы берете доски.';
used = function(s,w)
            if w^'Молот' or w^'Гвоздь' then
                                    if not have('Молот') then return 'Вбивать гвоздь голыми руками не очень сподручно.' end
                                    if not have('Гвоздь') then return 'Вам не нужны щепки.' end
                                    remove 'Гвоздь'
                                    remove 'Доски'
                                    place 'Крест'
                                    return 'Вы сколачиваете из досок импровизированный крест.'
            elseif string.match(w.nam,'Вес%d') then
                                    pn 'Вы не видите способов это соединить.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                                    pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                                    pn 'Вы не видите необходимости мыть доски.'
            elseif w^'Веретено' then
                                    pn 'Можно что-нибудь нацарапать, но вам ничего не идет в голову.'
            elseif w^'Клещи' then
                                    pn 'Вам не нужны щепки.'
            elseif w^'Слеза' then
                                    pn 'Не соединяется.'
            else
                return false
            end -- if
        end; -- func
}


obj {
nam = 'Крест';
dsc = '^Здесь лежит деревянный {крест}.';
inv = 'Большой деревянный крест, грубо сколоченный из пары досок.';
tak = 'Вы поднимаете крест и изучаете его. Доски были прогнившие и кривые, но крест получился аккуратный, с ровными сторонами, гладкий. Это добрый знак. Если крест покосившийся, если одно из плечей сломано — значит дело дрянь.';
used = function(s,w)
            if string.match(w.nam,'Вес%d') then
                pn 'Вы не видите способов это соединить.'
            elseif w^'Кувшин' and _'Кувшин'.sound~='' then -- Со звуком
                pn 'Если быть неосторожным, крышка приоткроется и звук выберется наружу.'
            elseif w^'Кувшин' and _'Кувшин'.withwater then -- С водой без звука
                pn 'Крест и так достаточно чистый.'
            elseif w^'Веретено' then
                pn 'Ничего хорошего не получилось.'
            elseif w^'Молот' then
                pn 'Вы легко ударяете молотом по кресту, производя деревянный стук.'
                makeSound('Стук','Из кувшина вырывается деревянный стук.')
            elseif w^'Клещи' then
                pn 'Нет нужды это разбирать.'
            elseif w^'Слеза' then
                pn 'Вы не видите способов это соединить.'
            else
                return false
            end -- if
        end; --func
}
